Batch update Agent Observability dataset records

Note: This endpoint is in preview and is subject to change. If you have any feedback, contact Datadog support.

POST https://api.ap1.datadoghq.com/api/v2/llm-obs/v1/{project_id}/datasets/{dataset_id}/batch_updatehttps://api.ap2.datadoghq.com/api/v2/llm-obs/v1/{project_id}/datasets/{dataset_id}/batch_updatehttps://api.datadoghq.eu/api/v2/llm-obs/v1/{project_id}/datasets/{dataset_id}/batch_updatehttps://api.ddog-gov.com/api/v2/llm-obs/v1/{project_id}/datasets/{dataset_id}/batch_updatehttps://api.us2.ddog-gov.com/api/v2/llm-obs/v1/{project_id}/datasets/{dataset_id}/batch_updatehttps://api.uk1.datadoghq.com/api/v2/llm-obs/v1/{project_id}/datasets/{dataset_id}/batch_updatehttps://api.datadoghq.com/api/v2/llm-obs/v1/{project_id}/datasets/{dataset_id}/batch_updatehttps://api.us3.datadoghq.com/api/v2/llm-obs/v1/{project_id}/datasets/{dataset_id}/batch_updatehttps://api.us5.datadoghq.com/api/v2/llm-obs/v1/{project_id}/datasets/{dataset_id}/batch_update

Overview

Insert, update, and delete records in a single dataset operation. By default, a new dataset version is created when the batch is applied.

Arguments

Path Parameters

Name

Type

Description

project_id [required]

string

The ID of the Agent Observability project.

dataset_id [required]

string

The ID of the Agent Observability dataset.

Request

Body Data (required)

Batch update payload.

Expand All

Field

Type

Description

data [required]

object

Data object for batch-updating records in an Agent Observability dataset.

attributes [required]

object

Attributes for batch-updating records in an Agent Observability dataset.

create_new_version

boolean

Whether to create a new dataset version when applying the batch update. Defaults to true.

delete_records

[string]

Record IDs to delete.

insert_records

[object]

Records to insert.

expected_output

object <oneOf>

Represents any valid JSON value.

Object 1

string

A scalar value represented as a string.

Object 2

double

A scalar numeric value.

Object 3

object

An arbitrary object value with additional properties.

Object 4

[ <oneOf>]

An array of arbitrary values.

Object 1

string

A scalar value represented as a string.

Object 2

double

A scalar numeric value.

Object 3

object

An arbitrary object value with additional properties.

Object 4

boolean

A scalar boolean value.

Object 5

boolean

A scalar boolean value.

id

string

Optional user-provided identifier for the record. If omitted, the server generates an identifier.

input [required]

object <oneOf>

Represents any valid JSON value.

Object 1

string

A scalar value represented as a string.

Object 2

double

A scalar numeric value.

Object 3

object

An arbitrary object value with additional properties.

Object 4

[ <oneOf>]

An array of arbitrary values.

Object 1

string

A scalar value represented as a string.

Object 2

double

A scalar numeric value.

Object 3

object

An arbitrary object value with additional properties.

Object 4

boolean

A scalar boolean value.

Object 5

boolean

A scalar boolean value.

metadata

object

Arbitrary metadata associated with the record.

tag_operations

object

Explicit tag operations for updating records. Operations are applied in order, Remove then Add then Set. set is the final override; if specified, the result of remove and add is discarded.

add

[string]

List of tag strings.

remove

[string]

List of tag strings.

set

[string]

List of tag strings.

tags

[string]

List of tag strings.

tags

[string]

List of tag strings.

update_records

[object]

Records to update by ID.

expected_output

object <oneOf>

Represents any valid JSON value.

Object 1

string

A scalar value represented as a string.

Object 2

double

A scalar numeric value.

Object 3

object

An arbitrary object value with additional properties.

Object 4

[ <oneOf>]

An array of arbitrary values.

Object 1

string

A scalar value represented as a string.

Object 2

double

A scalar numeric value.

Object 3

object

An arbitrary object value with additional properties.

Object 4

boolean

A scalar boolean value.

Object 5

boolean

A scalar boolean value.

id [required]

string

Unique identifier of the record to update.

input

object <oneOf>

Represents any valid JSON value.

Object 1

string

A scalar value represented as a string.

Object 2

double

A scalar numeric value.

Object 3

object

An arbitrary object value with additional properties.

Object 4

[ <oneOf>]

An array of arbitrary values.

Object 1

string

A scalar value represented as a string.

Object 2

double

A scalar numeric value.

Object 3

object

An arbitrary object value with additional properties.

Object 4

boolean

A scalar boolean value.

Object 5

boolean

A scalar boolean value.

metadata

object

Updated metadata associated with the record.

tag_operations

object

Explicit tag operations for updating records. Operations are applied in order, Remove then Add then Set. set is the final override; if specified, the result of remove and add is discarded.

add

[string]

List of tag strings.

remove

[string]

List of tag strings.

set

[string]

List of tag strings.

id [required]

string

Unique identifier of the dataset.

type [required]

enum

Resource type of an Agent Observability dataset. Allowed enum values: datasets

{
  "data": {
    "attributes": {
      "create_new_version": true,
      "delete_records": [],
      "insert_records": [
        {
          "expected_output": {
            "description": "undefined",
            "type": "undefined"
          },
          "id": "rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c",
          "input": {
            "description": "undefined",
            "type": "undefined"
          },
          "metadata": {},
          "tag_operations": {
            "add": [],
            "remove": [],
            "set": []
          },
          "tags": []
        }
      ],
      "tags": [],
      "update_records": [
        {
          "expected_output": {
            "description": "undefined",
            "type": "undefined"
          },
          "id": "rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c",
          "input": {
            "description": "undefined",
            "type": "undefined"
          },
          "metadata": {},
          "tag_operations": {
            "add": [],
            "remove": [],
            "set": []
          }
        }
      ]
    },
    "id": "9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d",
    "type": "datasets"
  }
}

Response

OK

Response containing records after a create or update operation.

Expand All

Field

Type

Description

data [required]

[object]

List of affected dataset records.

records [required]

[object]

List of affected dataset records.

created_at [required]

date-time

Timestamp when the record was created.

dataset_id [required]

string

Identifier of the dataset this record belongs to.

expected_output [required]

object <oneOf>

Represents any valid JSON value.

Object 1

string

A scalar value represented as a string.

Object 2

double

A scalar numeric value.

Object 3

object

An arbitrary object value with additional properties.

Object 4

[ <oneOf>]

An array of arbitrary values.

Object 1

string

A scalar value represented as a string.

Object 2

double

A scalar numeric value.

Object 3

object

An arbitrary object value with additional properties.

Object 4

boolean

A scalar boolean value.

Object 5

boolean

A scalar boolean value.

id [required]

string

Unique identifier of the record.

input [required]

object <oneOf>

Represents any valid JSON value.

Object 1

string

A scalar value represented as a string.

Object 2

double

A scalar numeric value.

Object 3

object

An arbitrary object value with additional properties.

Object 4

[ <oneOf>]

An array of arbitrary values.

Object 1

string

A scalar value represented as a string.

Object 2

double

A scalar numeric value.

Object 3

object

An arbitrary object value with additional properties.

Object 4

boolean

A scalar boolean value.

Object 5

boolean

A scalar boolean value.

metadata [required]

object

Arbitrary metadata associated with the record.

updated_at [required]

date-time

Timestamp when the record was last updated.

{
  "data": [
    {
      "records": [
        {
          "created_at": "2024-01-15T10:30:00Z",
          "dataset_id": "9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d",
          "expected_output": {
            "description": "undefined",
            "type": "undefined"
          },
          "id": "rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c",
          "input": {
            "description": "undefined",
            "type": "undefined"
          },
          "metadata": {},
          "updated_at": "2024-01-15T10:30:00Z"
        }
      ]
    }
  ]
}

Bad Request

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Unauthorized

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Forbidden

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Not Found

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Payload Too Large

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Too many requests

API error response.

Expand All

Field

Type

Description

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

Internal Server Error

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Code Example

                  ## default
# 

# Path parameters
export project_id="a33671aa-24fd-4dcd-9b33-a8ec7dde7751"
export dataset_id="9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d"
# Curl command
curl -X POST "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.uk1.datadoghq.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/llm-obs/v1/${project_id}/datasets/${dataset_id}/batch_update" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -H "DD-API-KEY: ${DD_API_KEY}" \ -H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \ -d @- << EOF { "data": { "attributes": { "create_new_version": true, "delete_records": [ "rec-old-record-1" ], "insert_records": [ { "expected_output": { "answer": "Paris" }, "input": { "question": "What is the capital of France?" }, "tags": [ "topic:geography" ] } ], "update_records": [ { "expected_output": { "answer": "Paris, France" }, "id": "rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c" } ] }, "id": "9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d", "type": "datasets" } } EOF
"""
Batch update Agent Observability dataset records returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.agent_observability_api import AgentObservabilityApi
from datadog_api_client.v2.model.llm_obs_dataset_batch_update_data_attributes_request import (
    LLMObsDatasetBatchUpdateDataAttributesRequest,
)
from datadog_api_client.v2.model.llm_obs_dataset_batch_update_data_request import LLMObsDatasetBatchUpdateDataRequest
from datadog_api_client.v2.model.llm_obs_dataset_batch_update_insert_record import LLMObsDatasetBatchUpdateInsertRecord
from datadog_api_client.v2.model.llm_obs_dataset_batch_update_request import LLMObsDatasetBatchUpdateRequest
from datadog_api_client.v2.model.llm_obs_dataset_batch_update_update_record import LLMObsDatasetBatchUpdateUpdateRecord
from datadog_api_client.v2.model.llm_obs_dataset_record_tag_operations import LLMObsDatasetRecordTagOperations
from datadog_api_client.v2.model.llm_obs_dataset_type import LLMObsDatasetType

body = LLMObsDatasetBatchUpdateRequest(
    data=LLMObsDatasetBatchUpdateDataRequest(
        attributes=LLMObsDatasetBatchUpdateDataAttributesRequest(
            create_new_version=True,
            delete_records=[],
            insert_records=[
                LLMObsDatasetBatchUpdateInsertRecord(
                    expected_output=None,
                    id="rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c",
                    input=None,
                    tag_operations=LLMObsDatasetRecordTagOperations(
                        add=[],
                        remove=[],
                        set=[],
                    ),
                    tags=[],
                ),
            ],
            tags=[],
            update_records=[
                LLMObsDatasetBatchUpdateUpdateRecord(
                    expected_output=None,
                    id="rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c",
                    input=None,
                    tag_operations=LLMObsDatasetRecordTagOperations(
                        add=[],
                        remove=[],
                        set=[],
                    ),
                ),
            ],
        ),
        id="9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d",
        type=LLMObsDatasetType.DATASETS,
    ),
)

configuration = Configuration()
configuration.unstable_operations["batch_update_llm_obs_dataset"] = True
with ApiClient(configuration) as api_client:
    api_instance = AgentObservabilityApi(api_client)
    response = api_instance.batch_update_llm_obs_dataset(project_id="project_id", dataset_id="dataset_id", body=body)

    print(response)

Instructions

First install the library and its dependencies and then save the example to example.py and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
# Batch update Agent Observability dataset records returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.batch_update_llm_obs_dataset".to_sym] = true
end
api_instance = DatadogAPIClient::V2::AgentObservabilityAPI.new

body = DatadogAPIClient::V2::LLMObsDatasetBatchUpdateRequest.new({
  data: DatadogAPIClient::V2::LLMObsDatasetBatchUpdateDataRequest.new({
    attributes: DatadogAPIClient::V2::LLMObsDatasetBatchUpdateDataAttributesRequest.new({
      create_new_version: true,
      delete_records: [],
      insert_records: [
        DatadogAPIClient::V2::LLMObsDatasetBatchUpdateInsertRecord.new({
          expected_output: nil,
          id: "rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c",
          input: nil,
          tag_operations: DatadogAPIClient::V2::LLMObsDatasetRecordTagOperations.new({
            add: [],
            remove: [],
            set: [],
          }),
          tags: [],
        }),
      ],
      tags: [],
      update_records: [
        DatadogAPIClient::V2::LLMObsDatasetBatchUpdateUpdateRecord.new({
          expected_output: nil,
          id: "rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c",
          input: nil,
          tag_operations: DatadogAPIClient::V2::LLMObsDatasetRecordTagOperations.new({
            add: [],
            remove: [],
            set: [],
          }),
        }),
      ],
    }),
    id: "9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d",
    type: DatadogAPIClient::V2::LLMObsDatasetType::DATASETS,
  }),
})
p api_instance.batch_update_llm_obs_dataset("project_id", "dataset_id", body)

Instructions

First install the library and its dependencies and then save the example to example.rb and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
// Batch update Agent Observability dataset records returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.LLMObsDatasetBatchUpdateRequest{
		Data: datadogV2.LLMObsDatasetBatchUpdateDataRequest{
			Attributes: datadogV2.LLMObsDatasetBatchUpdateDataAttributesRequest{
				CreateNewVersion: datadog.PtrBool(true),
				DeleteRecords:    []string{},
				InsertRecords: []datadogV2.LLMObsDatasetBatchUpdateInsertRecord{
					{
						ExpectedOutput: *datadogV2.NewNullableAnyValue(nil),
						Id:             datadog.PtrString("rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c"),
						Input:          *datadogV2.NewNullableAnyValue(nil),
						TagOperations: &datadogV2.LLMObsDatasetRecordTagOperations{
							Add:    []string{},
							Remove: []string{},
							Set:    []string{},
						},
						Tags: []string{},
					},
				},
				Tags: []string{},
				UpdateRecords: []datadogV2.LLMObsDatasetBatchUpdateUpdateRecord{
					{
						ExpectedOutput: *datadogV2.NewNullableAnyValue(nil),
						Id:             "rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c",
						Input:          *datadogV2.NewNullableAnyValue(nil),
						TagOperations: &datadogV2.LLMObsDatasetRecordTagOperations{
							Add:    []string{},
							Remove: []string{},
							Set:    []string{},
						},
					},
				},
			},
			Id:   "9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d",
			Type: datadogV2.LLMOBSDATASETTYPE_DATASETS,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.BatchUpdateLLMObsDataset", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewAgentObservabilityApi(apiClient)
	resp, r, err := api.BatchUpdateLLMObsDataset(ctx, "project_id", "dataset_id", body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `AgentObservabilityApi.BatchUpdateLLMObsDataset`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `AgentObservabilityApi.BatchUpdateLLMObsDataset`:\n%s\n", responseContent)
}

Instructions

First install the library and its dependencies and then save the example to main.go and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
// Batch update Agent Observability dataset records returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.AgentObservabilityApi;
import com.datadog.api.client.v2.model.LLMObsDatasetBatchUpdateDataAttributesRequest;
import com.datadog.api.client.v2.model.LLMObsDatasetBatchUpdateDataRequest;
import com.datadog.api.client.v2.model.LLMObsDatasetBatchUpdateInsertRecord;
import com.datadog.api.client.v2.model.LLMObsDatasetBatchUpdateRequest;
import com.datadog.api.client.v2.model.LLMObsDatasetBatchUpdateUpdateRecord;
import com.datadog.api.client.v2.model.LLMObsDatasetRecordTagOperations;
import com.datadog.api.client.v2.model.LLMObsDatasetRecordsMutationResponse;
import com.datadog.api.client.v2.model.LLMObsDatasetType;
import java.util.Collections;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.batchUpdateLLMObsDataset", true);
    AgentObservabilityApi apiInstance = new AgentObservabilityApi(defaultClient);

    LLMObsDatasetBatchUpdateRequest body =
        new LLMObsDatasetBatchUpdateRequest()
            .data(
                new LLMObsDatasetBatchUpdateDataRequest()
                    .attributes(
                        new LLMObsDatasetBatchUpdateDataAttributesRequest()
                            .createNewVersion(true)
                            .insertRecords(
                                Collections.singletonList(
                                    new LLMObsDatasetBatchUpdateInsertRecord()
                                        .expectedOutput(null)
                                        .id("rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c")
                                        .input(null)
                                        .tagOperations(new LLMObsDatasetRecordTagOperations())))
                            .updateRecords(
                                Collections.singletonList(
                                    new LLMObsDatasetBatchUpdateUpdateRecord()
                                        .expectedOutput(null)
                                        .id("rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c")
                                        .input(null)
                                        .tagOperations(new LLMObsDatasetRecordTagOperations()))))
                    .id("9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d")
                    .type(LLMObsDatasetType.DATASETS));

    try {
      LLMObsDatasetRecordsMutationResponse result =
          apiInstance.batchUpdateLLMObsDataset(
              "a33671aa-24fd-4dcd-9b33-a8ec7dde7751", "9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d", body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling AgentObservabilityApi#batchUpdateLLMObsDataset");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}

Instructions

First install the library and its dependencies and then save the example to Example.java and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
// Batch update Agent Observability dataset records returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_agent_observability::AgentObservabilityAPI;
use datadog_api_client::datadogV2::model::LLMObsDatasetBatchUpdateDataAttributesRequest;
use datadog_api_client::datadogV2::model::LLMObsDatasetBatchUpdateDataRequest;
use datadog_api_client::datadogV2::model::LLMObsDatasetBatchUpdateInsertRecord;
use datadog_api_client::datadogV2::model::LLMObsDatasetBatchUpdateRequest;
use datadog_api_client::datadogV2::model::LLMObsDatasetBatchUpdateUpdateRecord;
use datadog_api_client::datadogV2::model::LLMObsDatasetRecordTagOperations;
use datadog_api_client::datadogV2::model::LLMObsDatasetType;

#[tokio::main]
async fn main() {
    let body = LLMObsDatasetBatchUpdateRequest::new(LLMObsDatasetBatchUpdateDataRequest::new(
        LLMObsDatasetBatchUpdateDataAttributesRequest::new()
            .create_new_version(true)
            .delete_records(vec![])
            .insert_records(vec![LLMObsDatasetBatchUpdateInsertRecord::new(None)
                .expected_output(None)
                .id("rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c".to_string())
                .tag_operations(
                    LLMObsDatasetRecordTagOperations::new()
                        .add(vec![])
                        .remove(vec![])
                        .set(vec![]),
                )
                .tags(vec![])])
            .tags(vec![])
            .update_records(vec![LLMObsDatasetBatchUpdateUpdateRecord::new(
                "rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c".to_string(),
            )
            .expected_output(None)
            .input(None)
            .tag_operations(
                LLMObsDatasetRecordTagOperations::new()
                    .add(vec![])
                    .remove(vec![])
                    .set(vec![]),
            )]),
        "9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d".to_string(),
        LLMObsDatasetType::DATASETS,
    ));
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.BatchUpdateLLMObsDataset", true);
    let api = AgentObservabilityAPI::with_config(configuration);
    let resp = api
        .batch_update_llm_obs_dataset("project_id".to_string(), "dataset_id".to_string(), body)
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}

Instructions

First install the library and its dependencies and then save the example to src/main.rs and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
/**
 * Batch update Agent Observability dataset records returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.batchUpdateLLMObsDataset"] = true;
const apiInstance = new v2.AgentObservabilityApi(configuration);

const params: v2.AgentObservabilityApiBatchUpdateLLMObsDatasetRequest = {
  body: {
    data: {
      attributes: {
        createNewVersion: true,
        deleteRecords: [],
        insertRecords: [
          {
            expectedOutput: undefined,
            id: "rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c",
            input: null,
            tagOperations: {
              add: [],
              remove: [],
              set: [],
            },
            tags: [],
          },
        ],
        tags: [],
        updateRecords: [
          {
            expectedOutput: undefined,
            id: "rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c",
            input: undefined,
            tagOperations: {
              add: [],
              remove: [],
              set: [],
            },
          },
        ],
      },
      id: "9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d",
      type: "datasets",
    },
  },
  projectId: "project_id",
  datasetId: "dataset_id",
};

apiInstance
  .batchUpdateLLMObsDataset(params)
  .then((data: v2.LLMObsDatasetRecordsMutationResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));

Instructions

First install the library and its dependencies and then save the example to example.ts and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"